/*
tstlock.c Version 0.2.0  Btree test lock on database
Copyright (C) 2003-2010  dondalah721@yahoo.com (Dondalah)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

	Free Software Foundation, Inc.
	59 Temple Place - Suite 330
	Boston, MA  02111-1307, USA.
*/

/* Usage: tstlock filename */

#include <bthash.h>

void putstx(pgm)
char *pgm;
   {
   fprintf(stderr,"Usage %s filename\n", pgm);
   exit(1);
   } /* putstx */

int main(argc,argv)
int argc;
char **argv;
   {
   int opnerr;
   int rslt;
   btreefmt *bthdr;
   char dbname[256];
   if (argc != 2) putstx(*argv);
   strcpy(dbname,*(argv+1));

   printf("tstlock: before first open NOLOCK\n");
   bthdr = (btreefmt *) btopen(dbname,UPDT,NOLOCK,&opnerr);
   if (bthdr == NULL)
      {
      fprintf(stderr,"tstlock: open "
	 "error on first open %d\n", opnerr);
      exit(1);
      } /* open error */

   printf("opened as NOLOCK\n");
   rslt = btlock(bthdr);
   printf("after btlock:   rslt %d "
      "bthdr->lock %d\n",
      rslt, bthdr->lock);
   rslt = btunlock(bthdr);
   printf("after btunlock: rslt %d "
      "bthdr->lock %d\n",
      rslt, bthdr->lock);
   btclose(bthdr);

   printf("tstlock: before second open LOCK\n");
   bthdr = (btreefmt *) btopen(dbname,UPDT,LOCK,&opnerr);
   if (bthdr == NULL)
      {
      fprintf(stderr,"tstlock: open "
	 "error on second open %d\n", opnerr);
      exit(1);
      } /* open error */


   printf("opened as LOCK\n");
   rslt = btlock(bthdr);
   printf("after btlock:   rslt %d "
      "bthdr->lock %d\n",
      rslt, bthdr->lock);
   rslt = btunlock(bthdr);
   printf("after btunlock: rslt %d "
      "bthdr->lock %d\n",
      rslt, bthdr->lock);
   btclose(bthdr);

   return(0);
   } /* main */
